<?php
/*** COPYRIGHT NOTICE *********************************************************
 *
 * Copyright 2009-2016 ProjeQtOr - Pascal BERNARD - support@projeqtor.org
 * Contributors : -
 *
 * This file is part of ProjeQtOr.
 *
 * ProjeQtOr is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * ProjeQtOr is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for
 * more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * ProjeQtOr. If not, see <http://www.gnu.org/licenses/>.
 *
 * You can get complete code of ProjeQtOr, other resource, help and information
 * about contributors at http://www.projeqtor.org
 *
 *** DO NOT REMOVE THIS NOTICE ************************************************/

include_once '../tool/projeqtor.php';
//echo "workDetail.php";

$paramProject = '';
if (array_key_exists('idProject', $_REQUEST)) {
    $paramProject = trim($_REQUEST['idProject']);
    Security::checkValidId($paramProject);
}
$paramTeam = '';
if (array_key_exists('idTeam', $_REQUEST)) {
    $paramTeam = trim($_REQUEST['idTeam']);
    Security::checkValidId($paramTeam);
}
$paramYear = '';
if (array_key_exists('yearSpinner', $_REQUEST)) {
    $paramYear = $_REQUEST['yearSpinner'];
    $paramYear = Security::checkValidYear($paramYear);
};
$paramMonth = '';
if (array_key_exists('monthSpinner', $_REQUEST)) {
    $paramMonth = $_REQUEST['monthSpinner'];
    $paramMonth = Security::checkValidMonth($paramMonth);
};
$paramWeek = '';
if (array_key_exists('weekSpinner', $_REQUEST)) {
    $paramWeek = $_REQUEST['weekSpinner'];
    $paramWeek = Security::checkValidWeek($paramWeek);
};
$user = getSessionUser();

$periodType = $_REQUEST['periodType']; // not filtering as data as data is only compared against fixed strings
$periodValue = '';
if (array_key_exists('periodValue', $_REQUEST)) {
    $periodValue = $_REQUEST['periodValue'];
    $periodValue = Security::checkValidPeriod($periodValue);
}
// Header
$headerParameters = "";
if ($paramProject != "") {
    $headerParameters .= i18n("colIdProject") . ' : ' . htmlEncode(SqlList::getNameFromId('Project', $paramProject)) . '<br/>';
}
if ($paramTeam != "") {
    $headerParameters .= i18n("colIdTeam") . ' : ' . htmlEncode(SqlList::getNameFromId('Team', $paramTeam)) . '<br/>';
}
if ($periodType == 'year' or $periodType == 'month' or $periodType == 'week') {
    $headerParameters .= i18n("year") . ' : ' . $paramYear . '<br/>';
}
if ($periodType == 'month') {
    $headerParameters .= i18n("month") . ' : ' . $paramMonth . '<br/>';
}
if ($periodType == 'week') {
    $headerParameters .= i18n("week") . ' : ' . $paramWeek . '<br/>';
}
include "header.php";

$where = getAccesRestrictionClause('Activity', false, false, true, true);
//$where="1=1 ";
$where .= ($periodType == 'week') ? " and week='" . $periodValue . "'" : '';
$where .= ($periodType == 'month') ? " and month='" . $periodValue . "'" : '';
$where .= ($periodType == 'year') ? " and year='" . $periodValue . "'" : '';
if ($paramProject != '') {
    $where .= "and idProject in " . getVisibleProjectsList(true, $paramProject);
}
$order = "";
//echo $where;
$work = new Work();
$lstWork = $work->getSqlElementsFromCriteria(null, false, $where, $order);
$result = array();
$activities = array();
$activities_pid = array();
$activities_id = array();
$activitiesSummary = array();
$product = array();
$version = array();
$manager = array();
$project = array();
$description = array();
$parent = array();
$resources = array();
$sumActi = array();
$types = array();
$workingDate = array();
$project_type = '';
$project_client ='';
$project_group = '';
$project_type_name = array();
$project_client_name = array();
$project_group_name = array();
$assignedWork = array();
$billing = array();

foreach ($lstWork as $work) {
    if (!array_key_exists($work->idResource, $resources)) {
        $resources[$work->idResource] = SqlList::getNameFromId('Resource', $work->idResource);
    }

    $refType = $work->refType;
    $refId = $work->refId;
    $key = $refType . "#" . $refId;
    if (!array_key_exists($key, $activities)) {
        if ($refType) {
            $obj = new $refType($refId);
        } else {
            $obj = new Ticket();
        }

        $key = SqlList::getFieldFromId('Project', $obj->idProject, 'sortOrder') . '-' . $refType . "#" . $refId;

        $project_type = SqlList::getFieldFromId('Project', $obj->idProject, 'idProjectType');
        $project_client = SqlList::getFieldFromId('Project', $obj->idProject, 'idClient');
        $project_group = SqlList::getFieldFromId('Project', $obj->idProject, 'idOrganization');

        $project_type_name[$key] = SqlList::getFieldFromId('Type', $project_type, 'name');
        $project_client_name[$key] = SqlList::getFieldFromId('Client', $project_client, 'name');
        $project_group_name[$key] = SqlList::getFieldFromId('Organization', $project_group, 'name');

        $activities[$key] = $obj->name;
        $description[$key] = $obj->description;
        $workingDate[$key] = $work->workDate;

        $product[$key] 			= SqlList::getNameFromId('product', $obj->idProduct);
        $version[$key] 			= SqlList::getNameFromId('version', $obj->idTargetProductVersion);
        $manager[$key] 			= SqlList::getFieldFromId('resource', $obj->idContact, 'fullName');

		
        if (array_key_exists('idActivityType', $obj)) {
            $types[$key] = SqlList::getNameFromId('type', $obj->idActivityType);
            $activities_pid[$key] =  SqlList::getFieldFromId('type', $obj->externalReference, 'externalReference') ;
//            $activities_id[$key] =  SqlList::getFieldFromId('type', $obj->id, 'id') . '_'. $work->id;
            $activities_id[$key] =  SqlList::getFieldFromId('type', $obj->id, 'id');
            $activitiesSummary[$key] = SqlList::getFieldFromId('Activity',$obj->id,'crqSummary');  

// 			if(!empty($obj->idBudgetList)){
// 				$result = Sql::query('SELECT `id`,`name` FROM `plgcustomlist` WHERE `id`=' . $obj->idBudgetList);
// 				if (Sql::$lastQueryNbRows > 0) {
// 				// $billing[$key] = Sql::fetchLine($result)
// 				}
// 			}
 
        } elseif (array_key_exists('idTicketType', $obj)) {
            $types[$key] = SqlList::getNameFromId('type', $obj->idTicketType);
            $activities_pid[$key] =  SqlList::getFieldFromId('type', $obj->externalReference, 'externalReference');
//            $activities_id[$key] =  SqlList::getFieldFromId('type', $obj->id, 'id') . '_'. $work->id;
            $activities_id[$key] =  SqlList::getFieldFromId('type', $obj->id, 'id');
        } else {
            $types[$key] = SqlList::getNameFromId('type', $obj->idMeetingType);
//            $activities_id[$key] =  SqlList::getFieldFromId('type', $obj->id, 'id') . '_'. $work->id;
            $activities_id[$key] =  SqlList::getFieldFromId('type', $obj->id, 'id');
        }

        if ($refType == 'Project') {
            $parent[$key] = "[" . i18n('Project') . "]";
        } else {
            if (property_exists($obj, 'idActivity') and $obj->idActivity) {
                $parent[$key] = SqlList::getNameFromId('Activity', $obj->idActivity);
            } else {
                $parent[$key] = "";
            }
        }
        $project[$key] = SqlList::getNameFromId('Project', $obj->idProject);

        $assigned = SqlList::getFieldFromId('assignment', $work->idAssignment, 'assignedWork');
        if ($assigned !="") {
            $assignedWork[$work->idResource][$key]=$assigned;
        } else {
            $assignedWork[$work->idResource][$key]=0;
        }
    }
    if (!array_key_exists($work->idResource, $result)) {
        $result[$work->idResource] = array();
    }
    if (!array_key_exists($key, $result[$work->idResource])) {
        $result[$work->idResource][$key] = 0;
    }
    $result[$work->idResource][$key] += $work->work;
}
ksort($activities);
if (checkNoData($result)) {
    exit;
}

// title

echo '<table style="width:95%" align="center">
		<tr>
			<td class="reportTableHeader" style="width:15%">' . i18n('colIdProject') . '</td>
			<td class="reportTableHeader" style="width:5%">' . i18n('colType') . '</td>
			<td class="reportTableHeader" style="width:10%">' . i18n('Resource') . '</td>
			<td class="reportTableHeader" style="width:5%">' . i18n('colWork') . '</td>
			<td class="reportTableHeader" style="width:5%"> work date </td>
			
			<td class="reportTableHeader" style="width:5%"> Application </td>
			<td class="reportTableHeader" style="width:10%"> Deployment Details </td>
			<td class="reportTableHeader" style="width:5%"> CRQ </td>
			<td class="reportTableHeader" style="width:5%"> PID </td>
			
			<td class="reportTableHeader" style="width:5%">' . i18n('colIdClient') . '</td>
			<td class="reportTableHeader" style="width:5%">' . i18n('colIdOrganization') . '</td>

			<td class="reportTableHeader" style="width:5%"> Week </td>
			<td class="reportTableHeader" style="width:5%"> Period </td>

			
			<td class="reportTableHeader" style="width:10%">Billable</td>
			<td class="reportTableHeader" style="width:10%">PM</td>
			<td class="reportTableHeader" style="width:10%"> CRQ Summary </td>
			<td class="reportTableHeader" style="width:5%"> external Reference </td>
			<td class="reportTableHeader" style="width:5%"> record id </td>
		</tr>';

$csv_output = i18n('colIdProject') . ';'.
i18n('colType') . ';'.
i18n('Resource') . ';'.
i18n('colWork') . ';'.
'work date' . ';'.
'Application' .';'.
'Deployment Details' . ';'.
'CRQ' .';'.
'PID' .';'.
i18n('colIdClient') . ';'.
i18n('colIdOrganization') . ';'.
'Week'. ';'.
'Period'. ';'.
'Billable' .';'.
'PM' .';'.
'CRQ Summary'.';'.
'externalReference' . ';'.
'record id' .';'. PHP_EOL;

$sum = 0;
$assigned = 0;
asort($resources);
foreach ($resources as $idR => $nameR) {
    if ($paramTeam) {
        $res = new Resource($idR);
    }
    if (!$paramTeam or $res->idTeam == $paramTeam) {
        $sumRes = 0;
        $assignedRes = 0;
        echo '<tr>';
        

        foreach ($activities as $key => $nameA) {
            if (array_key_exists($idR, $result)) {
                if (array_key_exists($key, $result[$idR])) {
                    $val = $result[$idR][$key];
                    $sumRes += $val;
                    $sum += $val;

                    $assign = $assignedWork[$idR][$key];
                    $assignedRes += $assign;
                    $assigned += $assign;
                    
                    $date = new DateTime($workingDate[$key]);
                    $week = $date->format("W");
                                        
					echo '<td class="reportTableData" style="width:18%; text-align:left;">' . htmlEncode($project[$key]) . '</td>
					<td class="reportTableData" style="width:8%;  text-align:left;">' . htmlEncode($types[$key]) . '</td>
					<td class="reportTableLineHeader" style="width:15%" >' . htmlEncode($nameR) . '</td>
					<td class="reportTableData" style="width:5%">' . Work::displayWorkWithUnit($val) . '</td>
                    <td class="reportTableData" style="width:8%;  text-align:left;">' . htmlEncode($workingDate[$key]) . '</td>
                    <td class="reportTableData" style="width:7%;  text-align:left;">' . (isset($product[$key]) ? htmlEncode($product[$key]) : "") . '</td>
                    <td class="reportTableData" style="width:10%; text-align:left;">' . htmlEncode($nameA) . '</td>
					<td class="reportTableData" style="width:5%;  text-align:left;"></td>
					<td class="reportTableData" style="width:5%;  text-align:left;"></td>
                    <td class="reportTableData" style="width:8%;  text-align:left;">' . htmlEncode($project_client_name[$key]) . '</td>
                    <td class="reportTableData" style="width:8%;  text-align:left;">' . htmlEncode($project_group_name[$key]) . '</td>
                    <td class="reportTableData" style="width:8%;  text-align:left;">'. htmlEncode($week).'</td>
                    <td class="reportTableData" style="width:8%;  text-align:left;"></td>
					
					<td class="reportTableData" style="width:5%;  text-align:left;">' . (isset($billing[$key]) ? htmlEncode($billing[$key]) : "") .'</td>
					<td class="reportTableData" style="width:5%;  text-align:left;">' . (isset($manager[$key]) ? htmlEncode($manager[$key]) : "") .'</td>
                    <td class="reportTableData" style="width:7%;  text-align:left;">' . (isset($activitiesSummary[$key]) ? htmlEncode($activitiesSummary[$key]) : "") . '</td>
                    <td class="reportTableData" style="width:5%;  text-align:left;">' . (isset($activities_pid[$key]) ? htmlEncode($activities_pid[$key]) :"").'</td>
                    <td class="reportTableData" style="width:5%;  text-align:left;">' . htmlEncode($activities_id[$key]) . '</td>

                    </tr><tr>';

                    $csv_output .= htmlEncode($project[$key]) . ';' .
                    htmlEncode($types[$key]) .';'.
                    htmlEncode($nameR) . ';' .
                    trim(Work::displayWorkWithUnit($val), " h") . ';' .
                    htmlEncode($workingDate[$key]) . ';' .
                    (isset($product[$key]) ? htmlEncode($product[$key]). ';' : ';') .
                    htmlEncode($nameA) . ';' .
                   ' ;'.
                    ' ;'.
                    
                    htmlEncode($project_client_name[$key]) . ';' .
                    htmlEncode($project_group_name[$key]) . ';' .
                    htmlEncode($week). ' ;'.
                    ' ;'.
                    (isset($billing[$key]) ? htmlEncode($billing[$key]). ';' : ';').
                    (isset($manager[$key]) ? htmlEncode($manager[$key]). ';' : ';') . 
                    (isset($activitiesSummary[$key]) ? htmlEncode($activitiesSummary[$key]).';' : ';') .
                    (isset($activities_pid[$key])? htmlEncode($activities_pid[$key]). ';' : ';') .
                    htmlEncode($activities_id[$key]) . ';' . PHP_EOL ;
                    
                    unset($week);
                }
            }
        }
//         echo '<td class="reportTableColumnHeader">' . i18n('sum') . '</td>
//         	  <td class="reportTableColumnHeader">' . Work::displayWorkWithUnit($sumRes) . '</td>
//               <td class="reportTableColumnHeader" style="text-align:left;" colspan="13">' . $nameR . '</td>
//         </tr>';
    }
}
echo '<tr>
		<td class="reportTableHeader"></td>
		<td class="reportTableHeader">' . i18n('sum') . '</td>
		<td class="reportTableHeader">' . Work::displayWorkWithUnit($sum) . '</td>';
echo '	<td colspan="16" class="reportTableHeader"></td>
	</tr>
</table>';

$csv_output .= i18n('sum') . ';' . rtrim(Work::displayWorkWithUnit($sum), " h") . ';;;;;;;;;;;;;;;;' . PHP_EOL;

//echo '<pre>';
//print_r($project_type_name) ;
//print_r($project_client_name);
//print_r($project_group_name);
//echo '</pre>';

// var_dump($billing);

echo '<pre id="csv_export">' . PHP_EOL . $csv_output . '</pre>';
